#include <iostream>

using namespace std;

int main() {
    ios::sync_with_stdio(false);

    char c1, c2;
    int a1, a2;
    cin >> c1 >> c2;
    cin >> a1 >> a2;

    char slova[2] = { c1, c2 };
    int ukupno = a1 + a2;
    int i = 0;

    if (abs(a1 - a2) >= 2)
        cout << "nemoguce" << endl;
    else {
        if (a1 != a2) {
            i = a1 > a2 ? 0 : 1;
            cout << slova[i];
            i ^= 1;
            ukupno--;
        }

        while (ukupno-- > 0) {
            cout << slova[i];
            i ^= 1;
        }
    }

    return 0;
}